"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.swap = void 0;
const death_1 = __importDefault(require("death"));
const fs_1 = require("fs");
const promises_1 = require("fs/promises");
function rotate(package_json, keyin, keyout) {
    let next = {};
    const swapped = new Set(Object.keys(package_json)
        .filter(x => x.startsWith(keyin))
        .map(x => x.slice(keyin.length)));
    for (const [key, val] of Object.entries(package_json)
        .map(([key, val]) => key.startsWith(keyin) ? [key.slice(keyin.length), val] : [swapped.has(key) ? keyout + key : key, val])) {
        next[key] = val;
    }
    return next;
}
async function swap(action, partial) {
    if (!fs_1.existsSync('package.json'))
        throw Error('This function must be called in a directory with a package.json!');
    const original = await promises_1.readFile('package.json', { encoding: 'utf8' });
    const swapped = !partial || partial === 'swapin' ? rotate(JSON.parse(original), 'devswap:', 'swapdev:') : rotate(JSON.parse(original), 'swapdev:', 'devswap:');
    death_1.default(async (sig) => {
        await promises_1.writeFile('package.json', original, 'utf8');
        process.exit(1);
    });
    await promises_1.writeFile('package.json', JSON.stringify(swapped, null, 2) + '\n', 'utf8');
    try {
        await action();
    }
    catch (e) {
        console.log(e);
    }
    finally {
        if (partial)
            return;
        await promises_1.writeFile('package.json', original, 'utf8');
    }
}
exports.swap = swap;
